diff --git a/base/server/src/scriptlets/webapp_deployment.py b/base/server/src/scriptlets/webapp_deployment.py
index aa52009fb1a0e6deb3e33223bd2a0a672f043fad..e3bd1896eb99f5fda2f483f57bbcb42077ba1c22 100644
--- a/base/server/src/scriptlets/webapp_deployment.py
+++ b/base/server/src/scriptlets/webapp_deployment.py
@@ -25,8 +25,6 @@ import os
 
 # PKI Deployment Imports
 import pkiconfig as config
-from pkiconfig import pki_master_dict as master
-import pkihelper as util
 import pkimessages as log
 import pkiscriptlet
 
@@ -35,9 +33,10 @@ import pkiscriptlet
 class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
     rv = 0
 
-    def spawn(self):
-        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
-            if config.str2bool(master['pki_skip_installation']):
+    def spawn(self, deployer):
+        
+        if deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+            if config.str2bool(deployer.master_dict['pki_skip_installation']):
                 config.pki_log.info(log.SKIP_WEBAPP_DEPLOYMENT_SPAWN_1,
                                      __name__,
                                     extra=config.PKI_INDENTATION_LEVEL_1)
@@ -47,30 +46,30 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
 
             # Copy /usr/share/pki/server/webapps/ROOT
             # to <instance>/webapps/ROOT
-            util.directory.create(master['pki_tomcat_webapps_root_path'])
-            util.directory.copy(
+            deployer.directory.create(deployer.master_dict['pki_tomcat_webapps_root_path'])
+            deployer.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
                     "server",
                     "webapps",
                     "ROOT"),
-                master['pki_tomcat_webapps_root_path'],
+                deployer.master_dict['pki_tomcat_webapps_root_path'],
                 overwrite_flag=True)
 
-            util.directory.create(master['pki_tomcat_webapps_common_path'])
+            deployer.directory.create(deployer.master_dict['pki_tomcat_webapps_common_path'])
 
             # If desired and available,
             # copy selected server theme
             # to <instance>/webapps/pki
-            if config.str2bool(master['pki_theme_enable']) and\
-               os.path.exists(master['pki_theme_server_dir']):
-                util.directory.copy(master['pki_theme_server_dir'],
-                                    master['pki_tomcat_webapps_common_path'],
+            if config.str2bool(deployer.master_dict['pki_theme_enable']) and\
+               os.path.exists(deployer.master_dict['pki_theme_server_dir']):
+                deployer.directory.copy(deployer.master_dict['pki_theme_server_dir'],
+                                    deployer.master_dict['pki_tomcat_webapps_common_path'],
                                     overwrite_flag=True)
 
             # Copy /usr/share/pki/server/webapps/pki/js
             # to <instance>/webapps/pki/js
-            util.directory.copy(
+            deployer.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
                     "server",
@@ -78,13 +77,13 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                     "pki",
                     "js"),
                 os.path.join(
-                    master['pki_tomcat_webapps_common_path'],
+                    deployer.master_dict['pki_tomcat_webapps_common_path'],
                     "js"),
                 overwrite_flag=True)
 
             # Copy /usr/share/pki/server/webapps/pki/META-INF
             # to <instance>/webapps/pki/META-INF
-            util.directory.copy(
+            deployer.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
                     "server",
@@ -92,15 +91,15 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                     "pki",
                     "META-INF"),
                 os.path.join(
-                    master['pki_tomcat_webapps_common_path'],
+                    deployer.master_dict['pki_tomcat_webapps_common_path'],
                     "META-INF"),
                 overwrite_flag=True)
 
             # Copy /usr/share/pki/server/webapps/pki/admin
             # to <instance>/webapps/<subsystem>/admin
             # TODO: common templates should be deployed in common webapp
-            util.directory.create(master['pki_tomcat_webapps_subsystem_path'])
-            util.directory.copy(
+            deployer.directory.create(deployer.master_dict['pki_tomcat_webapps_subsystem_path'])
+            deployer.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
                     "server",
@@ -108,60 +107,60 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                     "pki",
                     "admin"),
                 os.path.join(
-                    master['pki_tomcat_webapps_subsystem_path'],
+                    deployer.master_dict['pki_tomcat_webapps_subsystem_path'],
                     "admin"),
                 overwrite_flag=True)
 
             # Copy /usr/share/pki/<subsystem>/webapps/<subsystem>
             # to <instance>/webapps/<subsystem>
-            util.directory.copy(
+            deployer.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
-                    master['pki_subsystem'].lower(),
+                    deployer.master_dict['pki_subsystem'].lower(),
                     "webapps",
-                    master['pki_subsystem'].lower()),
-                master['pki_tomcat_webapps_subsystem_path'],
+                    deployer.master_dict['pki_subsystem'].lower()),
+                deployer.master_dict['pki_tomcat_webapps_subsystem_path'],
                 overwrite_flag=True)
 
-            util.directory.create(
-                master['pki_tomcat_webapps_subsystem_webinf_classes_path'])
-            util.directory.create(
-                master['pki_tomcat_webapps_subsystem_webinf_lib_path'])
+            deployer.directory.create(
+                deployer.master_dict['pki_tomcat_webapps_subsystem_webinf_classes_path'])
+            deployer.directory.create(
+                deployer.master_dict['pki_tomcat_webapps_subsystem_webinf_lib_path'])
             # establish Tomcat webapps subsystem WEB-INF lib symbolic links
-            util.symlink.create(master['pki_certsrv_jar'],
-                master['pki_certsrv_jar_link'])
-            util.symlink.create(master['pki_cmsbundle'],
-                master['pki_cmsbundle_jar_link'])
-            util.symlink.create(master['pki_cmscore'],
-                master['pki_cmscore_jar_link'])
-            util.symlink.create(master['pki_cms'],
-                master['pki_cms_jar_link'])
-            util.symlink.create(master['pki_cmsutil'],
-                master['pki_cmsutil_jar_link'])
-            util.symlink.create(master['pki_nsutil'],
-                master['pki_nsutil_jar_link'])
-            if master['pki_subsystem'] == "CA":
-                util.symlink.create(master['pki_ca_jar'],
-                                    master['pki_ca_jar_link'])
-            elif master['pki_subsystem'] == "KRA":
-                util.symlink.create(master['pki_kra_jar'],
-                                    master['pki_kra_jar_link'])
-            elif master['pki_subsystem'] == "OCSP":
-                util.symlink.create(master['pki_ocsp_jar'],
-                                    master['pki_ocsp_jar_link'])
-            elif master['pki_subsystem'] == "TKS":
-                util.symlink.create(master['pki_tks_jar'],
-                                    master['pki_tks_jar_link'])
-            elif master['pki_subsystem'] == "TPS":
-                util.symlink.create(master['pki_tps_jar'],
-                                    master['pki_tps_jar_link'])
+            deployer.symlink.create(deployer.master_dict['pki_certsrv_jar'],
+                deployer.master_dict['pki_certsrv_jar_link'])
+            deployer.symlink.create(deployer.master_dict['pki_cmsbundle'],
+                deployer.master_dict['pki_cmsbundle_jar_link'])
+            deployer.symlink.create(deployer.master_dict['pki_cmscore'],
+                deployer.master_dict['pki_cmscore_jar_link'])
+            deployer.symlink.create(deployer.master_dict['pki_cms'],
+                deployer.master_dict['pki_cms_jar_link'])
+            deployer.symlink.create(deployer.master_dict['pki_cmsutil'],
+                deployer.master_dict['pki_cmsutil_jar_link'])
+            deployer.symlink.create(deployer.master_dict['pki_nsutil'],
+                deployer.master_dict['pki_nsutil_jar_link'])
+            if deployer.master_dict['pki_subsystem'] == "CA":
+                deployer.symlink.create(deployer.master_dict['pki_ca_jar'],
+                                    deployer.master_dict['pki_ca_jar_link'])
+            elif deployer.master_dict['pki_subsystem'] == "KRA":
+                deployer.symlink.create(deployer.master_dict['pki_kra_jar'],
+                                    deployer.master_dict['pki_kra_jar_link'])
+            elif deployer.master_dict['pki_subsystem'] == "OCSP":
+                deployer.symlink.create(deployer.master_dict['pki_ocsp_jar'],
+                                    deployer.master_dict['pki_ocsp_jar_link'])
+            elif deployer.master_dict['pki_subsystem'] == "TKS":
+                deployer.symlink.create(deployer.master_dict['pki_tks_jar'],
+                                    deployer.master_dict['pki_tks_jar_link'])
+            elif deployer.master_dict['pki_subsystem'] == "TPS":
+                deployer.symlink.create(deployer.master_dict['pki_tps_jar'],
+                                    deployer.master_dict['pki_tps_jar_link'])
             # set ownerships, permissions, and acls
-            util.directory.set_mode(master['pki_tomcat_webapps_subsystem_path'])
+            deployer.directory.set_mode(deployer.master_dict['pki_tomcat_webapps_subsystem_path'])
         return self.rv
 
-    def destroy(self):
-        if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+    def destroy(self, deployer):
+        if deployer.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             config.pki_log.info(log.WEBAPP_DEPLOYMENT_DESTROY_1, __name__,
                                 extra=config.PKI_INDENTATION_LEVEL_1)
-            util.directory.delete(master['pki_tomcat_webapps_subsystem_path'])
+            deployer.directory.delete(deployer.master_dict['pki_tomcat_webapps_subsystem_path'])
         return self.rv
-- 
1.7.10.2

